# KeyBoxen
| [Progress][progress] | [Discussions][maillist] | [Features & Bugs][tracker] | [Contributing][contrib] |

KeyBoxen is a standalone [freedesktop.org secret-service][org.fd.ss] daemon for window
managers. Secret service is DBus service that is used by desktop applications like NextCloud client,
and Evolution mail client to store secret credentials like passwords and API keys.

KeyBoxen stores these secrets as *keys*. These keys are stored in *boxes* that can be locked and
unlocked using passwords. The keys are identified using *tags*. Keys can also be locked
independently and/or per application session. These concepts are analogous to the secret service
[API][org.fd.ss] terminology as follows:

- **Keys** are analogous to **Items**
- **Boxes** are analogous to **Collections**
- **Tags** are analogous to **Attributes**

<!-- Use only reference style links listed here for project links. This makes it easy to update all -->
<!-- relevant links if something gets moved. -->
[maillist]: https://lists.sr.ht/~gokuldas/projects
[tracker]: https://todo.sr.ht/~gokuldas/KeyBoxen 
[progress]: https://todo.sr.ht/~gokuldas/KeyBoxen/4
[contrib]: CONTRIBUTING.md
[copying]: COPYING
[org.fd.ss]: https://specifications.freedesktop.org/secret-service/latest/

### Status
**Active early development** (As on: December, 2022)

Refer [progress tracking task][progress] for more details.

## Features
- Service over DBus using [secret-service API][org.fd.ss]
- Standalone daemon
- Dedicated service (won't take over other agents)
- Automatic secrets decryption upon login using PAM
- CLI tool for interaction with daemon
- Optional notifications upon access or deletion of secrets

## Usage
The project is not yet ready for testing or daily usage. Watch this location for updates on when it
is ready to do so.

## Related Information
1. Development progress & milestones: [Tracking task][progress]
2. Contributing to KeyBoxen: [CONTRIBUTING file][contrib]
3. Discussions and bug reporting: [Projects mailing list][maillist]
4. Patches and pull requests: [Project mailing list][maillist]
5. Feature and bugfix tasks: [Tasks tracker][tracker]

## License
Copyright (C) 2022 KeyBoxen Authors

The contents of this source tree are under GNU General Public License v3.0. Please refer [COPYING
file][copying] for details.
